c
c=====subroutine FP_AssignPrm =====================================
c
c	This subroutine assign the following parameters:
c
c	Description        Keyword       parametri
c	Project name       PROJECT       pro
c     Rest frequency     RESTFRQ       rf         [MHz]
c     Observing mode     OBSMODE       obs
c     Frequency offset   FRQOFF        offfr      [MHz]
c     Reference position REFPOS        mode       [km/s]
c     X offset           RALFA         ralfa      [deg]
c     Y offset           RDELTA        rdelta     [deg]
c
      subroutine FP_AssignPrm(keyword, params, ios)
	character*(*) keyword, params

	include 'header.inc'

	if(index(keyword,"PROJECT").eq.1) then
		read(params, *) pro
	else if(index(keyword,"RESTFRQ").eq.1) then
		read(params, *) rf
	else if(index(keyword,"OBSMODE").eq.1) then
		read(params, *) obs
	else if(index(keyword,"FRQOFF").eq.1) then
		read(params, *) offfr
	else if(index(keyword,"REFPOS").eq.1) then
		read(params, *) mode
	else if(index(keyword,"RALFA").eq.1) then
		read(params, *) ralfa
	else if(index(keyword,"RDELTA").eq.1) then
		read(params, *) rdelta
	else
		call err_message('Wrong or missing keyword')
	end if
	return
	end
