C--------------------     	Program ARCOBS ---------------------------
c programma che traduce un file di posizioni in formato DIRA in una
c schedula per ADLB4ARC.
c 
c	prima versione: C. Codella (1994)
c     seconda versione: F. Palagi (2001)
c		Introdotto l'uso di un file di parametri per specificare
c		alcuni parametri costanti in tutta la schedula.
c input : Da tastiera o da file:
c	    File di ingresso (formato DIRA)
c	    File di uscita
c	    Nome del progetto
c	    Frequenza di riposo della riga [MHz]
c	    Modo di osservazione {sou | ref | bmsw | frsw}
c	        Offset in Frequenza
c		  o
c		  Offset in RA e Dec
c
c output: Programma di osservazione per ADLB4ARC.
c 
c************************************************************************
	implicit double precision (a-h,o-z)
c
	character*100 prmfile
      integer outlu
c
	include 'header.inc'
	include 'source.inc'
c
	DATA cap7/'***'/

      character*1 u
      character*9 label
      character*20 filein,fileout
      character*256 buff
      integer ksour,bi1
	integer a11,b11,a22,b22
      real*8 vel,band,a33, b33
c
	nas=1000
	ksour=0
c
c  default output lu is the screen
c
      outlu = 6
      nargs = iargc()
      if(nargs.eq.0) then
		call InputParams(filein,fileout)
            open(unit=10,file=fileout,iostat=ios,err=400)
            outlu = 10
	else if(nargs.eq.2) then
            call getarg(1,filein)
            call getarg(2,prmfile)
		call read_prmfile(prmfile, ios)
      	if(ios.lt.-1) STOP 'Read param file'
      else
            call usage()
            stop
      end if
c
	open(1,file=filein)
c
	call header(outlu)
      do ii = 1,nas
c
c  Reads the next source from the input file
c
        read(1,300,end=999) buff
        read(buff,*) a1,b1,name,vel,tint,band,rep
	  label='         '
	  ksour=ksour+1
c
c  Converts the RA format from DIRA to h(a11), m(a22), s(a33)
c
	call ConvertRa(a1,a11,a22,a33)
c
	call ConvertDec(u,b1,b11,b22,b33)
c
      k=lnblnk(name)
      if(k.gt.8) k = 8
	do j=1,k
	  label(j:j)=name(j:j)
	enddo
	label(k+1:k+1)=':'
c	do j=1,rep
	   write(outlu,888) label
	   write(outlu,889) name
         write(outlu,884) a11,a22,a33
	   bi1=abs(b11)
	   if(bi1.lt.10) then
	      write(outlu,886) u,b11,b22,b33
c                  	   if(u.eq.'-'.and.bi1.lt.10) goto3
c                  	   if(u.eq.'+'.and.bi1.lt.10) goto3
	   else
         	write(outlu,885) u,b11,b22,b33
	   end if
c	   goto4
c3	   continue
c4	   continue
	   write(outlu,890) tint
	   write(outlu,891) band, band, band, band
	   write(outlu,892) vel, vel, vel, vel
	   write(outlu,899) rep
	   write(outlu,"('beep 3 s')")
	   write(outlu,"('run')")
	   write(outlu,893) cap7,name,cap7
c	enddo
c
c      
	end do
 999 	continue
   	write(outlu,"('input goto')")
	call OnError(outlu)
      write(outlu,"('stop:')")
      write(outlu,"('stop')")
      close(1)
	write(0, *) 'sources = ', ksour
      stop
 300  format(a)
 400  stop 'Error opening output file'
c
 884	format('sra50 ',i2,1x,i2,1x,f4.1)
 885	format('sdec50 ',a1,i2,1x,i2,1x,f4.1)
 886  format('sdec50 ',a1,i1,1x,i2,1x,f4.1)
 888	format(a9)
 889  format('source ',a8)
 890  format('intgtime ',i4,' s')
 891	format('acbandwidth ',4(f5.2,2x),' mhz')
 892	format('vlsr ',4(f7.2,2x),' km/s')
 893  format(a4,a8,' observed ',a4)
 898	format(a8)
 899	format('obscycles ',i2)
      end
c
c-------------------------------------------------------------
c     Inserimento parametri da tastiera
c-------------------------------------------------------------
c
	subroutine InputParams(filein,fileout)
	character*(*) filein, fileout
c
	include 'header.inc'
c
	print*, 'input file'
	read(*,'(a)') filein
c
	print*, 'Output file'
	read(*,'(a)') fileout
c
	print*, 'Project name (max 8 characters):'
	read(*,'(a8)') pro 
c
	print*, 'Line restfrequency (MHz):'
	read(*,*) rf
c
	print*, 'Observing mode (sou,ref,bmsw,frsw):'
	read(*,*) obs
c
	if(obs.eq.'frsw') then
		print*, 'Frequency offset (MHz):'
		read(*,*) offfr
		return
	else if(obs.eq.'sou') then
		return
	else
		print*, 'Mode of the reference position (radec,azel):'
		read(*,*) mode
		print*, 'Right ascension offset (degree):'
		read(*,*) ralfa
		print*, 'Declination offset (degree):'
		read(*,*) rdelta
	endif
c
	return
	end
c
	subroutine header(outlu)
      integer outlu
c
c  Prints the header of the schedule file
c
	include 'header.inc'
c
	DATA cap1/'project  ' /
	DATA cap2/'restfreq ' /
	DATA cap3/'obsmode  ' /
	DATA cap4/'refpos   ' /
	DATA cap5/'ralfa    ' /
	DATA cap6/'rdelta   ' /
	DATA cap8/'offsfreq ' /
	write(outlu,881) cap1,pro
	write(outlu,882) cap2,rf,rf, rf, rf
	write(outlu,881) cap3,obs
	if(obs.eq.'frsw') then
		write(outlu,882) cap8,offfr, offfr, offfr, offfr
	else if(obs.eq.'bmsw') then
		write(outlu,881) cap4,mode
		write(outlu,887) cap5,ralfa
		write(outlu,887) cap6,rdelta
	end if
	write(outlu,8833)
	write(outlu,883)
	call OnError(outlu)
c
 881	format(a9,1x,a8)
 882	format(a9,1x,4(f11.5,1x),' mhz')
 887  format(a9,1x,f8.4,' d')
 883	format('input goto')
 8833 format('error:')
	end
c
	subroutine OnError(outlu)
      integer outlu
c
	write(outlu,"('*** Source name not found ***')" ) 
	write(outlu,"('*** Please, type another name ***')" ) 
	write(outlu,"('goto error')")
	return
	end
c
	subroutine source()
c
	include 'source.inc'
c
	DATA cap7/'*** ' /

	return
	end
c
c----------------------------------------------
c  Conversione di formato da DIRA a h,m,s
c---------------------------------------------
c
	subroutine ConvertRa(a1,a11,a22,a33)
	integer a1
	integer a11, a22
	real*8  a33, a, c
c
c     
	a=a1*1e-7
	a11=abs(a)	
	c=(a-a11)*1e2
	a22=abs(c)
	a33=(c-a22)*1e2
	if(a33.gt.60.0) then
	a33=0.0
	a22=a22+1
	endif
	return
	end
c
c----------------------------------------------
c  Conversione di formato da DIRA a g,m,s
c---------------------------------------------
c
	subroutine ConvertDec(u,b1,b11,b22,b33)
	character*1 u
	integer b1
	integer b11, b22
	real*8  b33, b, d
c
      u='+'
	if(b1.lt.0) then
 	   b1=-b1
	   u='-'
	endif
	b=b1*1e-7	
	b11=abs(b)
	d=(b-b11)*1e2
	b22=abs(d)
	b33=(d-b22)*1e2
	if(b33.gt.60.0) then
	    b33=0.0
	    b22=b22+1
	endif
	return
	end
c
      subroutine usage()
      character*80 line
      write(*,*) 'Usage: arcobs input_file param_file '
      open(unit=12,
     .file='/home/loki/archivio/programmi/arcobs/arcobs.help')
10    read(12,100, end=200) line
	write(*,100) line
      goto 10
200   return
100   format(a)
      end
